package com.cooble.saltmod.main;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

import com.cooble.saltmod.blocks.BlocksManager;
import com.cooble.saltmod.event_hooks.ChokingPotionEventHook;
import com.cooble.saltmod.items.ItemsManager;
import com.cooble.saltmod.potions.SaltModPotions;
import com.cooble.tileentity.TileEntitySaltPort;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.potion.Potion;
import net.minecraftforge.common.MinecraftForge;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.LanguageRegistry;

@Mod(modid = Main.MODID, version = Main.VERSION)
public class Main
{
    public static final String MODID = "SulMod";
    public static final String VERSION = "1.0";


    @EventHandler
    public void preInit(FMLPreInitializationEvent event){
    	incrementPotionFieldLength(50);
    	BlocksManager.init();
    	BlocksManager.register();
    	ItemsManager.init();
    	ItemsManager.register();
    	Potion.potionTypes[33]=SaltModPotions.chokingPotion;
    }
   
    @EventHandler
    public void init(FMLInitializationEvent event)
    {
    	GameRegistry.addShapedRecipe(new ItemStack(BlocksManager.blockSul, 1), 
				"ss", 
				"ss",
				's', new ItemStack(ItemsManager.itemSul));
    	GameRegistry.addShapedRecipe(new ItemStack(ItemsManager.itemWand, 1), 
    			"d",
    			"s", 
				"s",
				's', new ItemStack(ItemsManager.itemSul),
				'd', new ItemStack(Items.diamond));
		//GameRegistry.registerTileEntity(TileEntitySaltPort.class, "TileEntitySaltPort");
    	MinecraftForge.EVENT_BUS.register(new ChokingPotionEventHook());


    }
    @EventHandler
    public void postInit(FMLPostInitializationEvent event){}  
    
    
    
    
    
    
    
    private void incrementPotionFieldLength(int newLength){
    	Potion[] potionTypes = null;

    	for (Field f : Potion.class.getDeclaredFields()) {
	    	f.setAccessible(true);
	    	try {
		    	if (f.getName().equals("potionTypes") || f.getName().equals("field_76425_a")) {
			    	Field modfield = Field.class.getDeclaredField("modifiers");
			    	modfield.setAccessible(true);
			    	modfield.setInt(f, f.getModifiers() & ~Modifier.FINAL);
			
			    	potionTypes = (Potion[])f.get(null);
			    	final Potion[] newPotionTypes = new Potion[newLength];
			    	System.arraycopy(potionTypes, 0, newPotionTypes, 0, potionTypes.length);
			    	f.set(null, newPotionTypes);
		    	}
	    	}
	    	catch (Exception e) {
	    	System.err.println("Error, cant increment length of potions field. Report this to a mod author.");
	    	System.err.println(e);
	    	}
    	}
    }
}
